#include <EEPROM.h>                   // needed for EEPROM

#define ROOF_CLOSED  0
#define ROOF_OPENED  1

int Relay[8] = {5,6,7,8,9,A2,A3,A4};
int Open_Pin = 5;
int Close_Pin = 6;
int roofState;
int lostConnectionCounter = 0;

void OpenRoof() {
  digitalWrite(Open_Pin, LOW); 
  delay(1000);              
  digitalWrite(Open_Pin, HIGH); 
  roofState = ROOF_OPENED;
  EEPROM.write(0, roofState);
}

void CloseRoof() {
  digitalWrite(Close_Pin, LOW); 
  delay(1000);              
  digitalWrite(Close_Pin, HIGH); 
  roofState = ROOF_CLOSED;
  EEPROM.write(0, roofState);
}
     
bool stringContains(String s, String search) {
    int max = s.length() - search.length();

    for (int i = 0; i <= max; i++) {
        if (s.substring(i) == search) return true; // or i
    }
    return false; //or -1
} 

void setup() {
  roofState = EEPROM.read(0);
  pinMode(Open_Pin, OUTPUT);
  digitalWrite(Open_Pin, HIGH); 
  
  pinMode(Close_Pin, OUTPUT);
  digitalWrite(Close_Pin, HIGH); 
  Serial.begin(9600);
  delay(1000);  
  CloseRoof();
}
     
void processCommand() {
  String command = Serial.readString();

  if (stringContains(command, "Status")) {
    if (roofState == ROOF_CLOSED)
      Serial.println("SHUTTER CLOSED");
    else
      Serial.println("SHUTTER OPENED");
    lostConnectionCounter = 0;
    return;
  }

  if (stringContains(command, "Open")) {
    OpenRoof();
    Serial.println("SHUTTER OPENED");
    lostConnectionCounter = 0;
    return;
  }

  if (stringContains(command, "Close")) {
    CloseRoof();
    Serial.println("SHUTTER CLOSED");
    lostConnectionCounter = 0;
    return;
  }
}

void loop() {
  if (Serial.available() > 0) {
    processCommand();
  }
  lostConnectionCounter++;
  delay(100);
  if (lostConnectionCounter > 3000) {
     if (roofState != ROOF_CLOSED) CloseRoof();
     Serial.println("Connection lost. Roof closed");
     lostConnectionCounter = 0;
  }
}

